package com.ruoyi.base.service.impl;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;

import com.ruoyi.base.domain.baseCabinetInfoTreeSelects;
import com.ruoyi.common.utils.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.base.mapper.BaseCabinetInfoMapper;
import com.ruoyi.base.domain.BaseCabinetInfo;
import com.ruoyi.base.service.IBaseCabinetInfoService;

/**
 * 电柜信息Service业务层处理
 *
 * @author ruoyi
 * @date 2024-10-31
 */
@Service
public class BaseCabinetInfoServiceImpl implements IBaseCabinetInfoService
{
    @Autowired
    private BaseCabinetInfoMapper baseCabinetInfoMapper;

    /**
     * 查询电柜信息
     *
     * @param objId 电柜信息主键
     * @return 电柜信息
     */
    @Override
    public BaseCabinetInfo selectBaseCabinetInfoByObjId(Long objId)
    {
        return baseCabinetInfoMapper.selectBaseCabinetInfoByObjId(objId);
    }

    /**
     * 查询电柜信息列表
     *
     * @param baseCabinetInfo 电柜信息
     * @return 电柜信息
     */
    @Override
    public List<BaseCabinetInfo> selectBaseCabinetInfoList(BaseCabinetInfo baseCabinetInfo)
    {
        return baseCabinetInfoMapper.selectBaseCabinetInfoList(baseCabinetInfo);
    }

    /**
     * 新增电柜信息
     *
     * @param baseCabinetInfo 电柜信息
     * @return 结果
     */
    @Override
    public int insertBaseCabinetInfo(BaseCabinetInfo baseCabinetInfo)
    {
        Long cabinetCode = baseCabinetInfo.getCabinetCode();
        BaseCabinetInfo saveBaseCabinet = new BaseCabinetInfo();
        saveBaseCabinet.setCabinetCode(cabinetCode);
        List<BaseCabinetInfo> baseCabinetInfoList = baseCabinetInfoMapper.selectBaseCabinetInfoList(saveBaseCabinet);
        if (!baseCabinetInfoList.isEmpty()){
            throw new RuntimeException("该电柜编号已存在,请重新输入");
        }

        return baseCabinetInfoMapper.insertBaseCabinetInfo(baseCabinetInfo);
    }

    /**
     * 修改电柜信息
     *
     * @param baseCabinetInfo 电柜信息
     * @return 结果
     */
    @Override
    public int updateBaseCabinetInfo(BaseCabinetInfo baseCabinetInfo)
    {
        Long cabinetCode = baseCabinetInfo.getCabinetCode();
        BaseCabinetInfo saveBaseCabinet = new BaseCabinetInfo();
        saveBaseCabinet.setCabinetCode(cabinetCode);
        List<BaseCabinetInfo> baseCabinetInfoList = baseCabinetInfoMapper.selectBaseCabinetInfoList(saveBaseCabinet);
        if (!baseCabinetInfoList.isEmpty()
                && !baseCabinetInfo.getObjId().equals(baseCabinetInfoList.get(0).getObjId())){
            throw new RuntimeException("该电柜编号已存在,请重新输入");
        }
        return baseCabinetInfoMapper.updateBaseCabinetInfo(baseCabinetInfo);
    }

    /**
     * 批量删除电柜信息
     *
     * @param objIds 需要删除的电柜信息主键
     * @return 结果
     */
    @Override
    public int deleteBaseCabinetInfoByObjIds(Long[] objIds)
    {
        return baseCabinetInfoMapper.deleteBaseCabinetInfoByObjIds(objIds);
    }

    /**
     * 删除电柜信息信息
     *
     * @param objId 电柜信息主键
     * @return 结果
     */
    @Override
    public int deleteBaseCabinetInfoByObjId(Long objId)
    {
        return baseCabinetInfoMapper.deleteBaseCabinetInfoByObjId(objId);
    }

    /**
     * 查询电柜信息树列表
     *
     * @return 所有电柜信息信息
     */
    public List<baseCabinetInfoTreeSelects> selectCabinetInfoTreeList(BaseCabinetInfo baseCabinetInfo){
        List<BaseCabinetInfo> baseCabinetInfos = baseCabinetInfoMapper.selectBaseCabinetInfoList(baseCabinetInfo);
        return baseCabinetInfos.stream().map(baseCabinetInfoTreeSelects::new).collect(Collectors.toList());
    }

/*
    */
/**
     * 构建前端所需要下拉树结构
     *
     * @param
     * @return 下拉树结构列表
     *//*

        @Override
        public List<TreeSelects> buildCabinetInfoTreeSelect(List<BaseCabinetInfo> baseCabinetInfos)
        {
            List<BaseCabinetInfo> deptTrees = buildCabinetInfoTree(baseCabinetInfos);
            return deptTrees.stream().map(TreeSelects::new).collect(Collectors.toList());
        }

    */
/**
     * 构建前端所需要树结构
     *
     * @param
     * @return 树结构列表
     *//*

    @Override
    public List<BaseCabinetInfo> buildMonitorInfoTree(List<BaseCabinetInfo> baseCabinetInfos)
    {
        List<BaseCabinetInfo> returnList = new ArrayList<BaseCabinetInfo>();
        List<Long> tempList = baseCabinetInfos.stream().map(BaseCabinetInfo::getObjId).collect(Collectors.toList());
        for (BaseCabinetInfo baseMonitorInfo : baseCabinetInfos)
        {
            // 如果是顶级节点, 遍历该父节点的所有子节点
            if (!tempList.contains(baseMonitorInfo.getParentId()))
            {
                recursionFn(baseCabinetInfos, baseMonitorInfo);
                returnList.add(baseMonitorInfo);
            }
        }
        if (returnList.isEmpty())
        {
            returnList = baseCabinetInfos;
        }
        return returnList;
    }

    */
/**
     * 递归列表
     *//*

    private void recursionFn(List<BaseCabinetInfo> list, BaseCabinetInfo t)
    {
        // 得到子节点列表
        List<BaseCabinetInfo> childList = getChildList(list, t);
        t.setChildren(childList);
        for (BaseCabinetInfo tChild : childList)
        {
            if (hasChild(list, tChild))
            {
                recursionFn(list, tChild);
            }
        }
    }
    */
/**
     * 得到子节点列表
     *//*

    private List<BaseCabinetInfo> getChildList(List<BaseCabinetInfo> list, BaseCabinetInfo t)
    {
        List<BaseCabinetInfo> tlist = new ArrayList<BaseCabinetInfo>();
        Iterator<BaseCabinetInfo> it = list.iterator();
        while (it.hasNext())
        {
            BaseCabinetInfo n = (BaseCabinetInfo) it.next();
            if (StringUtils.isNotNull(n.getParentId()) && n.getParentId().longValue() == t.getObjId().longValue())
            {
                tlist.add(n);
            }
        }
        return tlist;
    }

    */
/**
     * 判断是否有子节点
     *//*

    private boolean hasChild(List<BaseCabinetInfo> list, BaseCabinetInfo t)
    {
        return getChildList(list, t).size() > 0;
    }
*/

}
